/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.liferay.account.rest.resource.v1_0;

import com.liferay.account.rest.dto.v1_0.Account;
import com.liferay.portal.kernel.search.Sort;
import com.liferay.portal.kernel.search.filter.Filter;
import com.liferay.portal.kernel.service.GroupLocalService;
import com.liferay.portal.kernel.service.RoleLocalService;
import com.liferay.portal.vulcan.accept.language.AcceptLanguage;
import com.liferay.portal.vulcan.pagination.Page;
import com.liferay.portal.vulcan.pagination.Pagination;

import java.util.Locale;

import javax.annotation.Generated;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import javax.ws.rs.core.Response;
import javax.ws.rs.core.UriInfo;

import org.osgi.annotation.versioning.ProviderType;

/**
 * To access this resource, run:
 *
 *     curl -u your@email.com:yourpassword -D - http://localhost:8080/o/account-rest/v1.0
 *
 * @author Drew Brokke
 * @generated
 */
@Generated("")
@ProviderType
public interface AccountResource {

	public static Builder builder() {
		return FactoryHolder.factory.create();
	}

	public Page<Account> getAccountsPage(
			String keywords, Filter filter, Pagination pagination, Sort[] sorts)
		throws Exception;

	public Account postAccount(Account account) throws Exception;

	public Response postAccountBatch(String callbackURL, Object object)
		throws Exception;

	public void deleteAccountByExternalReferenceCode(
			String externalReferenceCode)
		throws Exception;

	public Account getAccountByExternalReferenceCode(
			String externalReferenceCode)
		throws Exception;

	public Account patchAccountByExternalReferenceCode(
			String externalReferenceCode, Account account)
		throws Exception;

	public Account putAccountByExternalReferenceCode(
			String externalReferenceCode, Account account)
		throws Exception;

	public void deleteAccount(Long accountId) throws Exception;

	public Response deleteAccountBatch(String callbackURL, Object object)
		throws Exception;

	public Account getAccount(Long accountId) throws Exception;

	public Account patchAccount(Long accountId, Account account)
		throws Exception;

	public Account putAccount(Long accountId, Account account) throws Exception;

	public Response putAccountBatch(String callbackURL, Object object)
		throws Exception;

	public void patchOrganizationMoveAccounts(
			Long sourceOrganizationId, Long targetOrganizationId, Long[] longs)
		throws Exception;

	public void patchOrganizationMoveAccountsByExternalReferenceCode(
			Long sourceOrganizationId, Long targetOrganizationId,
			String[] strings)
		throws Exception;

	public void deleteOrganizationAccounts(Long organizationId, Long[] longs)
		throws Exception;

	public void postOrganizationAccounts(Long organizationId, Long[] longs)
		throws Exception;

	public void deleteOrganizationAccountsByExternalReferenceCode(
			Long organizationId, String[] strings)
		throws Exception;

	public void postOrganizationAccountsByExternalReferenceCode(
			Long organizationId, String[] strings)
		throws Exception;

	public default void setContextAcceptLanguage(
		AcceptLanguage contextAcceptLanguage) {
	}

	public void setContextCompany(
		com.liferay.portal.kernel.model.Company contextCompany);

	public default void setContextHttpServletRequest(
		HttpServletRequest contextHttpServletRequest) {
	}

	public default void setContextHttpServletResponse(
		HttpServletResponse contextHttpServletResponse) {
	}

	public default void setContextUriInfo(UriInfo contextUriInfo) {
	}

	public void setContextUser(
		com.liferay.portal.kernel.model.User contextUser);

	public void setGroupLocalService(GroupLocalService groupLocalService);

	public void setRoleLocalService(RoleLocalService roleLocalService);

	public static class FactoryHolder {

		public static volatile Factory factory;

	}

	@ProviderType
	public interface Builder {

		public AccountResource build();

		public Builder checkPermissions(boolean checkPermissions);

		public Builder httpServletRequest(
			HttpServletRequest httpServletRequest);

		public Builder preferredLocale(Locale preferredLocale);

		public Builder user(com.liferay.portal.kernel.model.User user);

	}

	@ProviderType
	public interface Factory {

		public Builder create();

	}

}